// 7k_wdt_statusDlg.cpp : implementation file
//

#include "stdafx.h"
#include "string.h"
#include "7k_wdt_status.h"
#include "7k_wdt_statusDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy7k_wdt_statusDlg dialog

CMy7k_wdt_statusDlg::CMy7k_wdt_statusDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy7k_wdt_statusDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k_wdt_statusDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy7k_wdt_statusDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CMy7k_wdt_statusDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMy7k_wdt_statusDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CMy7k_wdt_statusDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CMy7k_wdt_statusDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CMy7k_wdt_statusDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CMy7k_wdt_statusDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CMy7k_wdt_statusDlg::OnBnClickedButton7)
END_MESSAGE_MAP()


// CMy7k_wdt_statusDlg message handlers

BOOL CMy7k_wdt_statusDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	SetDlgItemText(IDC_COMBO1, L"COM2:");
	SetDlgItemText(IDC_EDIT1, L"01");
	SetDlgItemText(IDC_EDIT2, L"9600");
	SetDlgItemText(IDC_EDIT3, L"2");
	SetDlgItemText(IDC_EDIT4, L"50");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy7k_wdt_statusDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MY7K_WDT_STATUS_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MY7K_WDT_STATUS_DIALOG));
	}
}
#endif

bool bAPI_IS_RUN = false;
HANDLE hAPI_Thread;
HANDLE hPort;

DWORD API_Thread(PVOID pContext)
{

	while (bAPI_IS_RUN)
	{
		//OnBnClickedButton7();
	}
	return 0;
}


void CMy7k_wdt_statusDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	TCHAR OpenPort[10];
	TCHAR temp[20];
	char port[20];

	//get user set com port and buad rate
	GetDlgItemText(IDC_COMBO1, OpenPort, 10);

	GetDlgItemText(IDC_EDIT2, temp, 20);
	int BuadRate = _wtoi(temp);

	int address = _wtoi(temp);
	//uart_Open parameter format is COMx,buadrate  , for ex will set COM3 port and baud rate 9600 to uart_Open,
	//parameter is "COM3,9600"
	sprintf(port, "%ls,%d", OpenPort, BuadRate);
	hPort = uart_Open(port);

	if(hPort == INVALID_HANDLE_VALUE)
	{
		::MessageBox(NULL, L"Open Port Error", L"7k_wdt_status", MB_OK);
	}
	else
	{
		GetDlgItem(IDC_BUTTON1)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON3)->EnableWindow(TRUE);
	}

	if (!bAPI_IS_RUN)
	{
		hAPI_Thread = CreateThread(NULL, 0, API_Thread, NULL, CREATE_SUSPENDED, NULL);
		if (hAPI_Thread)
		{
			
			ResumeThread(hAPI_Thread);	//_Thread
		}
	}

	//OnBnClickedButton7();
}

void CMy7k_wdt_statusDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here

	//close com port
	if(!uart_Close(hPort))
	{
		::MessageBox(NULL, L"Close Port Error", L"7k_wdt_status", MB_OK);
	}
	else
	{
		GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON3)->EnableWindow(FALSE);
	}

	bAPI_IS_RUN=false;
}

void CMy7k_wdt_statusDlg::OnBnClickedButton3()
{
	// TODO: b[JiBz`{X
	TCHAR temp[20];
	CString strTemp;
	float fValue = 0.0;

	//get user set address
	GetDlgItemText(IDC_EDIT1, temp, 20);
	int address = _wtoi(temp);

	//get user set WTD Timeout
	GetDlgItemText(IDC_EDIT4, temp, 20);
	int WTDTimeout = _wtoi(temp);

	//use pac_SetModuleWDTConfig function
	BOOL iret = pac_SetModuleWDTConfig(hPort, PAC_REMOTE_IO(address), 1, WTDTimeout, 0);

	if(!iret)
	{
		::MessageBox(NULL, L"Config WDT error", L"7k_wdt_safe", MB_OK);
	}
}

void CMy7k_wdt_statusDlg::OnBnClickedButton4()
{
	// TODO: b[JiBz`{X
	TCHAR temp[20];

	//get user set address
	GetDlgItemText(IDC_EDIT1, temp, 20);
	int address = _wtoi(temp);

	short ebStatus;
	ulong WTDTimeout;
	int WTDOverwrite;
	//use pac_GetModuleWDTConfig function
	BOOL iret = pac_GetModuleWDTConfig(hPort, PAC_REMOTE_IO(address), &ebStatus, &WTDTimeout, &WTDOverwrite);

	if(!iret)
	{
		::MessageBox(NULL, L"Get Module WDT Config error", L"7k_wdt_safe", MB_OK);
	}
	else
	{
		wsprintf(temp, L"%u", WTDTimeout);
		SetDlgItemText(IDC_EDIT4, temp);
	}
}

void CMy7k_wdt_statusDlg::OnBnClickedButton5()
{
	// TODO: b[JiBz`{X
	TCHAR temp[20];
	CString strTemp;
	float fValue = 0.0;

	//get user set address
	GetDlgItemText(IDC_EDIT1, temp, 20);
	int address = _wtoi(temp);

	//use pac_SetModuleWDTConfig function
	BOOL iret = pac_ResetModuleWDT(hPort, PAC_REMOTE_IO(address));

	if(!iret)
	{
		::MessageBox(NULL, L"Reset Module WDT error", L"7k_wdt_safe", MB_OK);
	}
}

void CMy7k_wdt_statusDlg::OnBnClickedButton6()
{
	// TODO: b[JiBz`{X
	TCHAR temp[20];
	CString strTemp;
	float fValue = 0.0;

	//get user set address
	GetDlgItemText(IDC_EDIT1, temp, 20);
	int address = _wtoi(temp);

	//use pac_SetModuleWDTConfig function
	BOOL iret = pac_RefreshModuleWDT(hPort, PAC_REMOTE_IO(address));

	if(!iret)
	{
		::MessageBox(NULL, L"Refresh Module WDT error", L"7k_wdt_safe", MB_OK);
	}
}

void CMy7k_wdt_statusDlg::OnBnClickedButton7()
{
		WORD Status;
		TCHAR temp[20];

		//get user set address
		GetDlgItemText(IDC_EDIT1, temp, 20);
		int address = _wtoi(temp);

		Status = pac_GetModuleLastOutputSource(hPort, PAC_REMOTE_IO(address));
		if(Status == 0)
		{
			wsprintf(temp, L"Disable");
		}
		else if(Status == 2)
		{
			wsprintf(temp, L"Enable");
		}
		else if(Status == -1)
		{
			wsprintf(temp, L"CMD Time Out");
		}
		SetDlgItemText(IDC_EDIT3, temp);
}
