﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _k_wdt_status
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private IntPtr hPort = IntPtr.Zero;

        private int iAddress;

       // private int iCurrentCh;

       // private int iTotalCh;

       // private float fValue;

        private void GetTxtValue()
        {
            iAddress = PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text));
            // Get slot  
            // iCurrentCh = Convert.ToInt32(txtCurrentCH.Text)
            // iTotalCh = Convert.ToInt32(txtTotalCH.Text)
            // fValue = Convert.ToSingle(txtValue.Text)
        }

        private void btnOpen_Click(object sender, System.EventArgs e)
        {
            hPort = PACNET.UART.Open((cmbCOMPort.Text + ("," + cmbBaudRate.Text)));
            btnOpen.Enabled = false;
            btnClose.Enabled = true;
            Timer1.Enabled = true;
        }

        private void btnClose_Click(object sender, System.EventArgs e)
        {
            PACNET.UART.Close(hPort);
            btnOpen.Enabled = true;
            btnClose.Enabled = false;
            Timer1.Enabled = false;
        }

        private void btnCfgWDT_Click(object sender, System.EventArgs e)
        {
            GetTxtValue();
            int WTDTimeout = 0;
            WTDTimeout = Convert.ToInt32(txtbWTDTimeout.Text);
            bool iRet = PACNET.PAC_IO.SetModuleWDTConfig(hPort, iAddress, 1, WTDTimeout, 0);
            // 87k module without WTDOverwrite
            if (!iRet)
            {
                System.UInt32 ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((((PACNET.ErrCode)(ec)).ToString() + "\n") + ("Error Code: 0x" + ec.ToString("X"))));
            }
        }

        private void btnGetWDT_Click(object sender, System.EventArgs e)
        {
            GetTxtValue();
            // pac_GetModuleWDTConfig
            int WTDOverwrite = 0;
            int WTDTimeout = 0;
            short ebStatus = 0;
            bool iRet = PACNET.PAC_IO.GetModuleWDTConfig(hPort, iAddress, ref ebStatus,ref WTDTimeout, ref WTDOverwrite);
            
            if (!iRet)
            {
                System.UInt32 ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((((PACNET.ErrCode)(ec)).ToString() + "\n") + ("Error Code: 0x" + ec.ToString("X"))));
            }
            txtbWTDTimeout.Text = WTDTimeout.ToString();
        }

        private void btnRestWDT_Click(object sender, System.EventArgs e)
        {
            GetTxtValue();
            bool iRet = PACNET.PAC_IO.ResetModuleWDT(hPort, iAddress);
            if (!iRet)
            {
                System.UInt32 ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((((PACNET.ErrCode)(ec)).ToString() + "\n") + ("Error Code: 0x" + ec.ToString("X"))));
            }
        }

        private void btnRefreshWDT_Click(object sender, System.EventArgs e)
        {
            GetTxtValue();
            bool iRet = PACNET.PAC_IO.RefreshModuleWDT(hPort, iAddress);
            if (!iRet)
            {
                System.UInt32 ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((((PACNET.ErrCode)(ec)).ToString() + "\n") + ("Error Code: 0x" + ec.ToString("X"))));
            }
        }

        private void Timer1_Tick(object sender, EventArgs e)
        {
            short sStatus = PACNET.PAC_IO.GetModuleLastOutputSource(hPort, iAddress);
            if ((sStatus == 0))
            {
                // disable
                TextBox1.Text = "Disable";
            }
            else if ((sStatus == 2))
            {
                // enable
                TextBox1.Text = "Enable";
            }
            else if ((sStatus == -1))
            {
                // time out
                TextBox1.Text = "CMD Time Out";
            }
        }
    }
}