﻿Public Class Form1

    Dim hPort As IntPtr
    Dim DiValue As UInteger = 0
    Dim HighValue As UInteger = 0
    Dim LowValue As UInteger = 0
    'byte byteOnoff = 0;

    Private Sub btnOn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOn.Click
        Dim intChannel As Integer = Integer.Parse(txtTotalChannel.Text)
        Dim iRet As Boolean
        'Open com port
        hPort = PACNET.UART.Open("COM" + cmbComPort.Text + "," + txtBaudRate.Text)
        If (hPort = CType(-1, IntPtr)) Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError
            MessageBox.Show((CType(ec, PACNET.ErrCode).ToString + ("Error Code: 0x" + ec.ToString("X"))))
        End If

        'Read module data
        iRet = PACNET.PAC_IO.ReadDI(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), Convert.ToInt16(txtTotalChannel.Text), DiValue)
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError
            MessageBox.Show((CType(ec, PACNET.ErrCode).ToString + ("Error Code: 0x" + ec.ToString("X"))))
        End If

        txtReadDIValue.Text = DiValue.ToString

        'Read DI High latch Data
        HighValue = 0
        iRet = PACNET.PAC_IO.ReadDILatch(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), intChannel, 1, HighValue)
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError
            MessageBox.Show((CType(ec, PACNET.ErrCode).ToString + ("Error Code: 0x" + ec.ToString("X"))))
        End If

        txtHighValue.Text = HighValue.ToString
        'Read DI Low latch Data
        LowValue = 0
        iRet = PACNET.PAC_IO.ReadDILatch(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), intChannel, 0, LowValue)
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError
            MessageBox.Show((CType(ec, PACNET.ErrCode).ToString + ("Error Code: 0x" + ec.ToString("X"))))
        End If

        txtLowValue.Text = LowValue.ToString
        'close com port
        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnOff_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOff.Click
        'Open com port
        hPort = PACNET.UART.Open("COM" + cmbComPort.Text + "," + txtBaudRate.Text)
        If (hPort = CType(-1, IntPtr)) Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError
            MessageBox.Show((CType(ec, PACNET.ErrCode).ToString + ("Error Code: 0x" + ec.ToString("X"))))
        End If

        Dim iRet As Boolean = PACNET.PAC_IO.ClearDILatch(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)))
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError
            MessageBox.Show((CType(ec, PACNET.ErrCode).ToString + ("Error Code: 0x" + ec.ToString("X"))))
        End If

        'Close com port
        PACNET.UART.Close(hPort)
        txtReadDIValue.Text = "0"
        txtHighValue.Text = "0"
        txtLowValue.Text = "0"
    End Sub
End Class
