﻿Imports PACNET


Public Class Form1
    Dim hPort As IntPtr
    Dim DIValue As UInteger
    Dim DIHighLatchValue As UInteger
    Dim DILowLatchValue As UInteger
    Dim DOValue As UInteger
    Dim DOHighLatchValue As UInteger
    Dim DOLowLatchValue As UInteger
    Dim intDiTotalCh As Integer
    Dim intDoTotalCh As Integer

    Private Sub btnOn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOn.Click
        intDiTotalCh = Convert.ToInt16(txtTotalDiChannel.Text)
        intDoTotalCh = Convert.ToInt16(txtTotalDoChannel.Text)
        'Open com port
        hPort = PACNET.UART.Open("COM" + cmbComPort.Text + "," + txtBaudRate.Text)
        DIValue = 0
        DOValue = 0
        Dim iRet As Boolean = PACNET.PAC_IO.ReadDIO(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), intDiTotalCh, intDoTotalCh, DIValue, DOValue)
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError
            MessageBox.Show((CType(ec, PACNET.ErrCode).ToString + ("Error Code: 0x" + ec.ToString("X"))))
        End If

        txtReadDIValue.Text = DIValue.ToString("X")
        txtReadDoValue.Text = DOValue.ToString("X")
        DILowLatchValue = 0
        DOLowLatchValue = 0
        'Read DI and DO low latch data
        iRet = PACNET.PAC_IO.ReadDIOLatch(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), intDiTotalCh, intDoTotalCh, 0, DILowLatchValue, DOLowLatchValue)
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError
            MessageBox.Show((CType(ec, PACNET.ErrCode).ToString + ("Error Code: 0x" + ec.ToString("X"))))
        End If

        txtDiLowValue.Text = DILowLatchValue.ToString("X")
        txtDoLowValue.Text = DOLowLatchValue.ToString("X")
        DIHighLatchValue = 0
        DOHighLatchValue = 0
        'Read DI and DO high latch data
        iRet = PACNET.PAC_IO.ReadDIOLatch(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), intDiTotalCh, intDoTotalCh, 1, DIHighLatchValue, DOHighLatchValue)
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError
            MessageBox.Show((CType(ec, PACNET.ErrCode).ToString + ("Error Code: 0x" + ec.ToString("X"))))
        End If

        txtDiHighValue.Text = DIHighLatchValue.ToString("X")
        txtDoHighValue.Text = DOHighLatchValue.ToString("X")
        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnOff_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOff.Click
        'Open com port
        hPort = PACNET.UART.Open("COM" + cmbComPort.Text + "," + txtBaudRate.Text)
        Dim iRet As Boolean = PACNET.PAC_IO.ClearDIOLatch(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)))
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError
            MessageBox.Show((CType(ec, PACNET.ErrCode).ToString + ("Error Code: 0x" + ec.ToString("X"))))
        End If

        'Set DO data be '0' to clear
        txtDiLowValue.Text = "0"
        txtDiHighValue.Text = "0"
        txtDoHighValue.Text = "0"
        txtDoLowValue.Text = "0"
        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnWriteDo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWriteDo.Click
        Dim iRet As Boolean
        hPort = PACNET.UART.Open("COM" + cmbComPort.Text + "," + txtBaudRate.Text)
        iRet = PACNET.PAC_IO.WriteDO(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), Convert.ToInt32(txtTotalDoChannel.Text), Convert.ToUInt32(txtDOWriteValue.Text, 16))
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError
            MessageBox.Show((CType(ec, PACNET.ErrCode).ToString + ("Error Code: 0x" + ec.ToString("X"))))
        End If

        PACNET.UART.Close(hPort)
    End Sub
End Class
