﻿Public Class Form1
    Private hPort As IntPtr = IntPtr.Zero
    Private iAddress As Integer
    Private iCurrentCh As Integer
    Private iTotalCh As Integer
    Private fValue As Single
    Private Sub GetTxtValue()
        iAddress = PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text))

        'Get slot  
        'iCurrentCh = Convert.ToInt32(txtCurrentCH.Text)
        'iTotalCh = Convert.ToInt32(txtTotalCH.Text)
        'fValue = Convert.ToSingle(txtValue.Text)
    End Sub
    Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click
        hPort = PACNET.UART.Open(cmbCOMPort.Text + "," + cmbBaudRate.Text)
        btnOpen.Enabled = False
        btnClose.Enabled = True
        Timer1.Enabled = True
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        PACNET.UART.Close(hPort)
        btnOpen.Enabled = True
        btnClose.Enabled = False
        Timer1.Enabled = False
    End Sub

    Private Sub btnCfgWDT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCfgWDT.Click
        GetTxtValue()

        Dim WTDTimeout As Integer = 0

        WTDTimeout = Convert.ToInt32(txtbWTDTimeout.Text)

        Dim iRet As Boolean = PACNET.PAC_IO.SetModuleWDTConfig(hPort, iAddress, 1, WTDTimeout, 0)
        '87k module without WTDOverwrite
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If
    End Sub
    Private Sub btnGetWDT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetWDT.Click
        GetTxtValue()

        'pac_GetModuleWDTConfig
        Dim WTDOverwrite As Integer = 0
        Dim WTDTimeout As Integer = 0
        Dim ebStatus As Short = 0

        Dim iRet As Boolean = PACNET.PAC_IO.GetModuleWDTConfig(hPort, iAddress, ebStatus, WTDTimeout, WTDOverwrite)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        txtbWTDTimeout.Text = WTDTimeout.ToString()
    End Sub

    Private Sub btnRestWDT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRestWDT.Click
        GetTxtValue()

        Dim iRet As Boolean = PACNET.PAC_IO.ResetModuleWDT(hPort, iAddress)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If
    End Sub

    Private Sub btnRefreshWDT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRefreshWDT.Click
        GetTxtValue()

        Dim iRet As Boolean = PACNET.PAC_IO.RefreshModuleWDT(hPort, iAddress)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim sStatus As Short = PACNET.PAC_IO.GetModuleLastOutputSource(hPort, iAddress)

        If sStatus = 0 Then                       'disable
            TextBox1.Text = "Disable"
        ElseIf sStatus = 2 Then                   'enable
            TextBox1.Text = "Enable"
        ElseIf sStatus = -1 Then                  'time out
            TextBox1.Text = "CMD Time Out"
        End If

    End Sub
End Class
